=== debian/changelog ===
glewlwyd (1.1-2ubuntu1) artful; urgency=medium

  * Build-depend on libmariadbclient-dev, not default-libmysqlclient-dev,
    since the latter conflicts with libhoel-dev in Ubuntu.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 22 Sep 2017 07:23:46 +0000

glewlwyd (1.1-2) unstable; urgency=medium

  * create fonts stuff within dh_install-indep (Closes: #871623)
  * put font package into fonts section (Closes: #871589)

 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 16 Aug 2017 20:39:01 +0200

glewlwyd (1.1-1) unstable; urgency=medium

  * Initial release

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 07 Aug 2017 19:39:01 +0200
