=== debian/control ===
Source: glewlwyd
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 10)
	, libmicrohttpd-dev
	, libjansson-dev
	, libcurl4-gnutls-dev
	, uuid-dev
	, libldap2-dev
	, libmariadbclient-dev
	, libsqlite3-dev
	, libconfig-dev
	, libgnutls28-dev
	, libssl-dev
	, libjwt-dev
	, liborcania-dev
	, libyder-dev
	, libulfius-dev
	, libhoel-dev
Standards-Version: 4.0.0
Homepage: https://github.com/babelouest/glewlwyd
#Vcs-Git: https://anonscm.debian.org/collab-maint/glewlwyd.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/glewlwyd.git

Package: glewlwyd
Architecture: any
Depends: ${shlibs:Depends}, 
	, ${misc:Depends}
	, lsb-base (>=3.0-6)
	, glewlwyd-common 
Description: OAuth2 authentication server providing Json Web Tokens 
 Lightweight, fast and easy to install on small systems. Requires a 
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius 
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens 
 library.

Package: glewlwyd-common
Depends: ${misc:Depends}
	, fonts-glewlwyd
Architecture: all
Description: OAuth2 authentication server providing Json Web Tokens - common files
 Lightweight, fast and easy to install on small systems. Requires a 
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius 
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens 
 library.
 .
 This package contains the architecture independent files.

Package: fonts-glewlwyd
Depends: ${misc:Depends}
	, fonts-font-awesome
Architecture: all
Section: fonts
Multi-Arch: foreign
Description: OAuth2 authentication server providing Json Web Tokens - font files
 Lightweight, fast and easy to install on small systems. Requires a 
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius 
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens 
 library.
 .
 This package contains the needed fonts.
