=== debian/changelog ===
glewlwyd (1.3.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.3 (no changes)
  * debian/control: use dh11

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 30 Jan 2018 19:05:19 +0100

glewlwyd (1.2.4-1) unstable; urgency=medium

  * New upstream release

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 21 Nov 2017 18:52:20 +0100

glewlwyd (1.2.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.1 (no changes)
  * debian/control: remove dependency on default-libmysqlclient-dev and
                    let libhoel-dev do the sql magic (Closes: #876714)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 07 Oct 2017 16:33:07 +0200

glewlwyd (1.2-1) unstable; urgency=medium

  * New upstream release
  * move config file to /etc/glewlwyd

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 15 Sep 2017 18:39:08 +0200

glewlwyd (1.1.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.0 (no changes)
  * debian/control: add VCS URLs
  * debian/control: set maintainer to team

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 05 Sep 2017 21:57:32 +0200
