=== debian/control ===
Source: glewlwyd
Section: web
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 11)
	, libmicrohttpd-dev
	, libjansson-dev
	, libcurl4-gnutls-dev
	, uuid-dev
	, libldap2-dev
	, libsqlite3-dev
	, libconfig-dev
	, libgnutls28-dev
	, libssl-dev
	, libjwt-dev
	, liborcania-dev
	, libyder-dev
	, libulfius-dev
	, libhoel-dev
Standards-Version: 4.1.3
Homepage: https://github.com/babelouest/glewlwyd
Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/glewlwyd.git
Vcs-Git: https://anonscm.debian.org/git/debian-iot/glewlwyd.git

Package: glewlwyd
Architecture: any
Depends: ${shlibs:Depends},
	, ${misc:Depends}
	, lsb-base (>=3.0-6)
	, glewlwyd-common
Description: OAuth2 authentication server providing Json Web Tokens
 Lightweight, fast and easy to install on small systems. Requires a
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens
 library.

Package: glewlwyd-common
Depends: ${misc:Depends}
	, fonts-glewlwyd
Architecture: all
Description: OAuth2 authentication server providing Json Web Tokens - common files
 Lightweight, fast and easy to install on small systems. Requires a
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens
 library.
 .
 This package contains the architecture independent files.

Package: fonts-glewlwyd
Depends: ${misc:Depends}
	, fonts-font-awesome
Architecture: all
Section: fonts
Multi-Arch: foreign
Description: OAuth2 authentication server providing Json Web Tokens - font files
 Lightweight, fast and easy to install on small systems. Requires a
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens
 library.
 .
 This package contains the needed fonts.
