=== src/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 CC=gcc
 #CC=clang
 CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
-LIBS=-lc -lulfius -lyder -ljansson -lorcania -lhoel -ljwt -lconfig -lldap -luuid -lgnutls -lcrypt
+LIBS=-lc -lulfius -lyder -ljansson -lorcania -lhoel -ljwt -lconfig -lldap -llber -luuid -lgnutls -lcrypt
 OBJECTS=glewlwyd.o authorization.o oauth.o webservice.o token.o user.o client.o admin.o scope.o resource.o password.o
 PREFIX=/usr/local
 CONFIG_FILE=../glewlwyd.conf
@@ -41,10 +41,10 @@
 release: glewlwyd
 
 %.o: %.c glewlwyd.h
-	$(CC) $(CFLAGS) $<
+	$(CC) $(CFLAGS) $(CPPFLAGS) $<
 
 glewlwyd: $(OBJECTS)
-	$(CC) -o $@ $^ $(LIBS)
+	$(CC) -o $@ $^ $(LIBS) $(LDFLAGS)
 
 memcheck: debug
 	valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./glewlwyd --config-file=$(CONFIG_FILE) 2>valgrind.txt
