=== debian/changelog ===
glewlwyd (1.4.6-1) unstable; urgency=medium

  * New upstream release
  * debian/glewlwyd.postinst: don't check if/usr/share/dbconfig-common/dpkg/
                              files are present, assume they are
  * debian/glewlwyd.config: don't check if/usr/share/dbconfig-common/dpkg/
                            files are present, assume they are
  * Fix lintian warning maintainer-script-lacks-debhelper-token

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 19 Jul 2018 19:51:51 -0400

glewlwyd (1.4.4-3) unstable; urgency=medium

  * debian/postinst: improve auto config

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 09 Jun 2018 15:35:12 -0400

glewlwyd (1.4.4-2) unstable; urgency=medium

  * debian/postinst: force chmod 600 to jwt certificates generated
  * debian/config: remove note template due to lintian warning

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 01 Jun 2018 19:37:57 -0400

glewlwyd (1.4.4-1) unstable; urgency=medium

  * New upstream release
  * debian/postinst: Add dbconfig script

 -- Nicolas Mora <nicolas@babelouest.org>  Wed, 23 May 2018 23:31:51 -0400

glewlwyd (1.4.3-2) unstable; urgency=medium

  * debian/postinst: Improve install with templates

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 19 May 2018 14:43:33 -0400

glewlwyd (1.4.3-1) unstable; urgency=medium

  * New upstream release
  * debian/rules: Use cmake as buildsystem
  * debian/docs: Add documentation

 -- Nicolas Mora <nicolas@babelouest.org>  Mon, 30 Apr 2018 10:44:42 -0400

glewlwyd (1.4.0-1) unstable; urgency=medium

  * New upstream release
  * postinst: Add default config

 -- Nicolas Mora <nicolas@babelouest.org>  Mon, 02 Apr 2018 13:31:00 -0400
