=== debian/control ===
--- 
+++ 
@@ -3,7 +3,10 @@
 Priority: optional
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
+          , Nicolas Mora <nicolas@babelouest.org>
 Build-Depends: debhelper (>= 11)
+  , dh-exec
+  , po-debconf
 	, libmicrohttpd-dev
 	, libjansson-dev
 	, libcurl4-gnutls-dev
@@ -18,10 +21,11 @@
 	, libyder-dev
 	, libulfius-dev
 	, libhoel-dev
-Standards-Version: 4.1.3
+	, cmake
+Standards-Version: 4.1.4
 Homepage: https://github.com/babelouest/glewlwyd
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/glewlwyd.git
-Vcs-Git: https://anonscm.debian.org/git/debian-iot/glewlwyd.git
+Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
+Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
 
 Package: glewlwyd
 Architecture: any
@@ -29,6 +33,9 @@
 	, ${misc:Depends}
 	, lsb-base (>=3.0-6)
 	, glewlwyd-common
+	, openssl
+	, sqlite3
+  , dbconfig-mysql | dbconfig-sqlite3 | dbconfig-no-thanks,
 Description: OAuth2 authentication server providing Json Web Tokens
  Lightweight, fast and easy to install on small systems. Requires a
  MySql or SQLite3 database. Handles LDAP or database for users backend.
