=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake --builddirectory=build
 
 override_dh_auto_install:
 	echo "do nothing here"
@@ -30,3 +30,4 @@
 	rm ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/fontawesome-webfont.ttf
 	ln -s /usr/share/fonts-font-awesome/fonts/FontAwesome.otf ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/FontAwesome.otf
 	ln -s /usr/share/fonts-font-awesome/fonts/fontawesome-webfont.ttf ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/fontawesome-webfont.ttf
+	dh_installdocs -A
